//DESCRIPTION: Illustrates scripting of Reflective Objects

//Header of anonymous function -- Gives the script a local namespace
//
(function()
{
//
// End  of header

//Is APID installed.?
if(!(app.hasOwnProperty ("setDataStore"))){
	alert("Please Install APID ToolAssistant!");
	return;
	}
//Are documents open?
if(app.documents.length<1){
	alert("No Documents Open!");
	return;
	}
var doc = app.documents[0];

//If the returned array is empty, the plugin is not installed
if(doc.loadedScriptedPlugins ("reflectiveobjects").length==0){
	alert("Reflective Objects Not Installed!");
	return;
	}

//The plugin is returned as a single-item array
var reflectiveObjectsPlugin = doc.loadedScriptedPlugins ("reflectiveobjects")[0];

//Disable reflection
reflectiveObjectsPlugin.handleScriptEvent ("externalDeactivateReflection");

//fiddle around with text frames
MoveAllTextFramesToLeft();

//enable reflection and record the positioning data
reflectiveObjectsPlugin.handleScriptEvent ("externalActivateReflection");

//swap pages
var theSpread = app.activeWindow.activeSpread;
if(theSpread.pages.length==2){
	theSpread.pages[0].move (LocationOptions.after, theSpread.pages[1]);
	}

//make sure objects reflect immediately!
reflectiveObjectsPlugin.handleScriptEvent ("externalReflectObjects");

function MoveAllTextFramesToLeft(){
	var theSpread = app.activeWindow.activeSpread;
	var theFrames = theSpread.textFrames;
	var thePage = theSpread.pages[0];
	var theLeft = thePage.bounds[1]+thePage.marginPreferences.left;
	for(var i=0;i<theFrames.length;i++){
		var theBounds = theFrames[i].geometricBounds;
		var theWidth = theBounds[3]-theBounds[1];
		theBounds[1]=theLeft;
		theBounds[3]=theLeft+theWidth;
		theFrames[i].geometricBounds=theBounds;
		
		// Always remove existing reflective settings before creating new ones!!!
		theFrames[i].label=theFrames[i].label.replace(/<ReflectiveObject\d>/,"");

		//set to reflect position
		theFrames[i].label+="<ReflectiveObject1>";
		}
	}

//Anonymous function footer (matches Header on top)
//
}
)();